
$s::PlayerFov = $pref::PlayerFov;
$s::DestFov = -1;
$s::fovSmoothDir = -1;

function s::fovSmoothTo(%destfov, %wep)
{
	//echo("--call to s::fovSmoothTo() dest "@%destfov@" with "@%wep);
	if((!($s::curwep == %wep)) && (%wep == 13)) return;
	
	if(%destfov < 60) {
		%destfov = 60;
	} else if(%destfov > 120) {
		%destfov = 120;
	}
	
	$s::DestFov = %destfov;
	
	if(%destfov > $pref::PlayerFov)
	{
		$s::fovSmoothDir = 1;
	}
	else if(%destfov < $pref::PlayerFov)
	{
		$s::fovSmoothDir = -1;
	}
	
	schedule::add("s::fovWorker();", $s::fovSmoothDel);
}

function s::fovWorker()
{
	//echo("--CGFOV--"@$s::DestFov@"--"@$pref::PlayerFov);
	if(!($s::DestFov == $pref::PlayerFov))
	{
		%new = $pref::PlayerFov;
		%new = %new + $s::fovSmoothDir;
		$pref::PlayerFov = %new;
		schedule::add("s::fovWorker();", $s::fovSmoothDel);
	}
}

function s::updateFOV(%wep)
{
	//echo("--call to s::updateFOV() with "@%wep);
	if(!$sp::CGFOV) return;
	if(getMountedItem(0) == -1) return;
	if($s::sensMode > 1) return;
	
	if(%wep == 13)
	{
		if($pref::PlayerFov == $s::fovSmoothDest) return;
		schedule::add("s::fovSmoothTo($s::fovSmoothDest,"@%wep@");", 0.5, cgtag);
		if(!($s::fovSensitivity == -1)) {
			%sensnew = $sp::sensDefault*$s::fovSensitivityFactor;
			schedule::add("s::SetSensitivity("@%sensnew@", "@%sensnew@");", 0.5, senstag);
		}
	}
	else
	{
		if($pref::PlayerFov == $s::PlayerFov) return;
		schedule::add("s::fovSmoothTo($s::PlayerFov,"@%wep@");", 0.1, noncgtag);
		if(!($s::fovSensitivity == -1))
			schedule::add("s::SetSensitivity($sp::sensDefault, $sp::sensDefault);", 0.1, senstag);
	}
}

function s::cgfovToggle()
{
	if($sp::CGFOV)
		s::updateFOV($s::curwep);
	else
		$pref::PlayerFov = $s::PlayerFov;
}

s::AddToggle(CGFOV, "Chaingun FOV adjuster", "s::cgfovToggle();");

event::Attach(eventWeaponChange, s::updateFOV);
event::Attach(eventExit, "$pref::PlayerFov=$s::PlayerFov;");
event::Attach(eventChangeMission, "$pref::PlayerFov=$s::PlayerFov;");
event::Attach(eventYouDied, "$pref::PlayerFov=$s::PlayerFov;");