$CountDown::Time = 30;
$CountDown::X = 75;
$CountDown::Y = 100;

function Countdown::Create()
{
	Hud::new("RPTCont", $CountDown::X, $CountDown::Y, 30, 16, "", "", true);
	newObject("RPTStr", FearGuiFormattedText, 10, -1, 0, 0);
	Hud::Add("RPTCont", "RPTStr");
	Control::SetVisible("RPTCont", false);
}

function Countdown::Update()
{
	if($Countdown::Time <= 10)
		remoteEval(2048, lmsg, "blip1");
		
	if($Countdown::Time<=30 && $Countdown::Time>20)
		%prefix = "<f0>";
	else if($Countdown::Time<=20 && $Countdown::Time>10)
		%prefix = "<f1>";
	else if($Countdown::Time==10)
		%prefix = "<f2>";
	else if($Countdown::Time<10)
		%prefix = "<f2>0";
	else %prefix = "";
	
	Control::SetValue("RPTStr", %prefix @ $Countdown::Time);
	
	if($Countdown::Time == 0) {
		Schedule::Add("Control::SetVisible(\"RPTCont\", false);", 1.5, "HideCountdown");
		Schedule::Cancel("Countdown");
	}
}

function Countdown::Timer()
{
	if($Countdown::Time > 0) {
		$CountDown::Time--;
		Countdown::Update();
		schedule::add("Countdown::Timer();", 1.0, "Countdown");
	}
}

function Countdown::HandlePackReceived(%item)
{
	if($sp::RepPackTimer && (%item == 30)) {
		Schedule::Cancel("HideCountdown");
		Control::SetVisible("RPTCont", true);
		$CountDown::Time = 30;
		Countdown::Update();
		Schedule::Add("Countdown::Timer();", 1, "Countdown");
	}
}

function Countdown::Toggle()
{
	if(!$sp::RepPackTimer) {
		Schedule::Cancel("Countdown");
		Control::SetVisible("RPTCont", false);
	}
} 

s::AddToggle(RepPackTimer, "Repair pack timer turned", "Countdown::Toggle();");

Countdown::Create();

event::Attach(eventItemReceived, CountDown::HandlePackReceived);