function smsg::Create()
{
	if($s::Huds[smsg]) {
		Hud::new("SMSGCont", $s::hud_smsg_X, $s::hud_smsg_Y, $s::HudWidth[smsg], $s::HudHeight[smsg], "", "", $sp::bgLevel);
		newObject("SMSGText", FearGuiFormattedText, 5, -1, 1000, 1000);
		Hud::Add("SMSGCont", "SMSGText");
	}
}

function smsg::Clear()
{
	for(%i=1;%i<=$s::smsgLines;%i++)
		$s::smsgRow[%i] = "";

	smsg::Update();
}

function smsg::Rotate()
{
	for(%i=1;%i<$s::smsgLines;%i++)
		$s::smsgRow[%i] = $s::smsgRow[%i+1];
}

function smsg::Update()
{
	for(%i=1;%i<=$s::smsgLines;%i++)
		%display = %display @ $s::smsgRow[%i] @ "\n";

	Control::SetValue("SMSGText", %display);
}

function smsg::onKillTrak(%killer, %victim, %wep)
{
	%kname = String::EscapeTags(Client::GetName(%killer));
	%vname = String::EscapeTags(Client::GetName(%victim));
  
	if(Client::GetTeam(%killer) == Team::Friendly())
		%font = $sp::FontColorF;
	else
		%font = $sp::FontColorE;
	
	if(Client::GetTeam(%victim) == Team::Friendly())
		%font2 = $sp::FontColorF;
	else
		%font2 = $sp::FontColorE;
  
	smsg::Rotate();
	if((%killer == %victim) || (%kname == ""))
		$s::smsgRow[$s::smsgLines] = "\t\t"@%font@%vname@$sp::FontColor@" : "@%wep;
	else
		$s::smsgRow[$s::smsgLines] = "\t\t"@%font@%kname@$sp::FontColor@" --> "@%font2@%vname@$sp::FontColor@" : "@%wep;
	smsg::Update();
}

function smsg::onFlagTaken(%team, %id)
{
	if(%team == Team::Friendly())
		%name = $sp::FontColorE@"FRIENDLY FLAG TAKEN ("@client::getName(%id)@")";
	else
		%name = $sp::FontColorF@"ENEMY FLAG TAKEN ("@client::getName(%id)@")";
	
	smsg::Rotate();
	$s::smsgRow[$s::smsgLines] = %name;
	smsg::Update();
}

function smsg::onFlagDropped(%team, %id)
{
	if(%team == Team::Friendly())
    	%name = $sp::FontColorE@"FRIENDLY FLAG DROPPED";
	else
		%name = $sp::FontColorF@"ENEMY FLAG DROPPED";
    
	smsg::Rotate();
	$s::smsgRow[$s::smsgLines] = %name;
	smsg::Update();
}

function smsg::onFlagReturned(%team, %id)
{
	if(%team == Team::Friendly())
    	%name = $sp::FontColorF@"FRIENDLY FLAG RETURNED ("@client::getName(%id)@")";
	else
    	%name = $sp::FontColorE@"ENEMY FLAG RETURNED ("@client::getName(%id)@")";
    
	smsg::Rotate();
	$s::smsgRow[$s::smsgLines] = %name;
	smsg::Update();
}

function smsg::onFlagCaptured(%team, %id)
{
	if(%team == Team::Friendly())
    	%name = $sp::FontColorE@"YOUR FLAG CAPTURED ("@client::getName(%id)@")";
	else
    	%name = $sp::FontColorF@"ENEMY FLAG CAPTURED ("@client::getName(%id)@")";

	smsg::Rotate();
	$s::smsgRow[$s::smsgLines] = %name;
	smsg::Update();
}

function smsg::onServerMessage(%msg)
{
	//echo("SERVER MESSAGE: "@%msg);
	if((%index = String::findSubStr(%msg, "~w")) != -1) {
		%snd = String::getSubStr(%msg, %index + 2, 25);
		sound(%snd);
		//echo("SERVER SOUND: "@%snd);
		%msg = String::getSubStr(%msg, 0, %index);
	}
  
	if(string::findSubStr(%msg, "FLOOD") != -1)
		return true;
	if(string::findSubStr(%msg, "Match ") != -1)
  		return true;
  	if(string::findSubStr(%msg, "You received ") != -1)
		return true;
	if(string::findSubStr(%msg, " harmed ") != -1)
		return true;
	if(string::findSubStr(%msg, " Friendly Fire ") != -1)
		return true;
	if(string::findSubStr(%msg, "mission") != -1)
  		return true;
  	if(string::findSubStr(%msg, "Vote") != -1)
  		return true;
  	if(string::findSubStr(%msg, " time limit ") != -1)
  		return true;
  	if(string::findSubStr(%msg, " ENABLED ") != -1)
  		return true;
  	if(string::findSubStr(%msg, " DISABLED ") != -1)
  		return true;
  	if(string::findSubStr(%msg, "Server ") != -1)
  		return true;
  	if(string::findSubStr(%msg, " mine") != -1)
  		return true;
  	if(string::findSubStr(%msg, "deploy") != -1)
  		return true;
  	if(string::findSubStr(%msg, " teamchanged ") != -1)
  		return true;
  
	return false;
}

if($s::Huds[smsg]) {
	smsg::Create();
	event::Attach(eventKillTrak, smsg::onKillTrak);
	event::Attach(eventFlagTaken, smsg::onFlagTaken);
	event::Attach(eventFlagDropped, smsg::onFlagDropped);
	event::Attach(eventFlagReturned, smsg::onFlagReturned);
	event::Attach(eventFlagCaptured, smsg::onFlagCaptured);
	event::Attach(eventServerMessage, smsg::onServerMessage);
	event::Attach(eventConnectionAccepted, smsg::Clear);
	event::Attach(eventChangeMission, smsg::Clear);
}