function thrower::Init()
{
	if ($thrower::FarThrow)
		$thrower::ThrowTime  = 75;
	else
		$thrower::ThrowTime  = 0;
	
	// ensure user typed in valid options
	$thrower::on = (($thrower::FirstItem == grenade) && $thrower::ThrowGrens) || 
			(($thrower::FirstItem == mine) && $thrower::ThrowMines);

	$thrower::TossOrder[0] = $thrower::FirstItem;

	// set up throw order
	if($thrower::ThrowGrens && $thrower::ThrowMines) {
		if($thrower::FirstItem == grenade)
			$thrower::TossOrder[1] = mine;
		else
			$thrower::TossOrder[1] = grenade;
	}
	else {
		$thrower::TossOrder[1] = $thrower::FirstItem;
	}
	
	// initialize thrownow
	$thrower::ThrowNow = 0;
}

thrower::Init();

function thrower::ToggleCurrentItemIndex()
{
	$thrower::CurrentItemIndex = !$thrower::CurrentItemIndex;
}

function thrower::Throw(%item)
{
	if(!$thrower::ThrowNow)
		return;

	// if we dont have any of current item
	if(!getItemCount($thrower::TossOrder[$thrower::CurrentItemIndex])) {
		// check to see if we are also out of other item
		thrower::ToggleCurrentItemIndex();
		// if we dont have any of other item
		if(!getItemCount($thrower::TossOrder[$thrower::CurrentItemIndex])) {
			$thrower::ThrowNow = 0;
			return;
		}
	}

	remoteEval(2048, throwItem, getItemType($thrower::TossOrder[$thrower::CurrentItemIndex]), $thrower::ThrowTime);
	if($thrower::Interleave)
		thrower::ToggleCurrentItemIndex();
	Schedule::add("thrower::Throw();", 0.6);
}

function thrower::Thrower()
{
	// if we turned of throwing because of user config error
	if(!$thrower::on)
 		return;

	// if thrower is on, turn it off
	if($thrower::ThrowNow)
		$thrower::ThrowNow = 0;
	else {
		// restore first item thrown
		$thrower::CurrentItemIndex = 0;
		
		$thrower::ThrowNow = 1;
		thrower::Throw();
	}
}