$s::weprotnext[11] = 15;
$s::weprotnext[15] = 13;
$s::weprotnext[13] = 21;
$s::weprotnext[21] = 17;
$s::weprotnext[17] = 19;
$s::weprotnext[19] = 22;
$s::weprotnext[22] = 24;
$s::weprotnext[24] = 11;

$s::weprotprev[11] = 24;
$s::weprotprev[15] = 11;
$s::weprotprev[13] = 15;
$s::weprotprev[21] = 13;
$s::weprotprev[17] = 21;
$s::weprotprev[19] = 17;
$s::weprotprev[22] = 19;
$s::weprotprev[24] = 22;

$s::ammo[11] = "";
$s::ammo[15] = "Plasma Bolt";
$s::ammo[13] = "Bullet";
$s::ammo[21] = "Disc";
$s::ammo[17] = "Grenade Ammo";
$s::ammo[19] = "Mortar Ammo";
$s::ammo[22] = "";
$s::ammo[24] = "";

$s::weps[11] = "Blaster";
$s::weps[15] = "Plasma Gun";
$s::weps[13] = "Chaingun";
$s::weps[21] = "Disc Launcher";
$s::weps[17] = "Grenade Launcher";
$s::weps[19] = "Mortar";
$s::weps[22] = "Laser Rifle";
$s::weps[24] = "ELF Gun";

function s::selectValidWeapon()
{
	%test = 11;
	for(%i = 0; %i < 8; %i++) {
		//echo("---selectValidWeapon.testing: " @ %test);
		if(s::wepIsSelectable(%test)) {
			return %test;
		}
		%test = $s::weprotnext[%test];
	}
	return -1;
}
        
function s::wepIsSelectable(%weapon)
{       
	if(getItemCount($s::weps[%weapon])) {
		%ammo = $s::ammo[%weapon];
		if(%ammo == "" || getItemCount(%ammo) > 0)
			return true;
	}
	return false;
}

function s::getNextWep(%curwep)
{
	for(%weapon = $s::weprotnext[%curwep]; %weapon != %curwep; %weapon = $s::weprotnext[%weapon]) {
		if(s::wepIsSelectable(%weapon)) {
			return %weapon;
		}
	}
}

function s::getPrevWep(%curwep)
{
	for(%weapon = $s::weprotprev[%curwep]; %weapon != %curwep; %weapon = $s::weprotprev[%weapon]) {
		if(s::wepIsSelectable(%weapon)) {
			return %weapon;
		}
	}
}


function nextWeapon()
{
	remoteEval(2048,nextWeapon);
	//%curwep = getMountedItem(0);
	%curwep = $s::curwep;
	if((%curwep == -1) || ($s::weprotnext[%curwep] == ""))
		%nexwep = s::selectValidWeapon();
	else
		%nexwep = s::getNextWep(%curwep);
	$s::curwep = %nexwep;
	//echo("--$s::curwep: "@$s::curwep);
	event::Trigger(eventNextWeapon, %nexwep);
	event::Trigger(eventWeaponChange, $s::curwep);
}	

function prevWeapon()
{
	remoteEval(2048,prevWeapon);
	//%curwep = getMountedItem(0);
	%curwep = $s::curwep;
	if((%curwep == -1)  || ($s::weprotprev[%curwep] == ""))
		%nexwep = s::selectValidWeapon();
	else
		%nexwep = s::getPrevWep(%curwep);
	$s::curwep = %nexwep;
	//echo("--$s::curwep: "@$s::curwep);
	event::Trigger(eventPrevWeapon, %nexwep);
	event::Trigger(eventWeaponChange, $s::curwep);
}

function s::weapsOnUseItem(%wep)
{
	if(s::isWep(%wep))
		$s::curwep = %wep;
	//echo("--$s::curwep: "@$s::curwep);
	event::Trigger(eventWeaponChange, $s::curwep);
}

function s::weapsOnItemReceived(%wep)
{
	if(s::isWep(%wep) && !(%wep == 21))
		$s::curwep = %wep;
	//echo("--$s::curwep: "@$s::curwep);
	event::Trigger(eventWeaponChange, $s::curwep);
}

function s::weapsReset()
{
	$s::curwep = getMountedItem(0);
	//echo("--$s::curwep: "@$s::curwep);
	event::Trigger(eventWeaponChange, $s::curwep);
}

function s::isWep(%item)
{
	if(!($s::weps[%item]==""))
		return true;
	else
		return false;
}

function s::getAmmo(%wep)
{
	return $s::ammo[%wep];
}

function s::weapsOnMapChange()
{
	$s::curwep = "";
}

function s::dropWeap()
{
	$s::curwep = "";
	drop(Weapon);
	event::Trigger(eventWeaponChange, $s::curwep);
}

event::Attach(eventUseItem, s::weapsOnUseItem);
event::Attach(eventItemReceived, s::weapsOnItemReceived);
event::Attach(eventYouSpawned, s::weapsReset);
event::Attach(eventChangeMission, s::weapsOnMapChange);