// DONT DISPLAY INVENTORY LIST
$pref::noEnterInvStation = true;

// AUTO STATION TURN AROUND SPEEDS
// These are used to turn you around in at an invenory station. Higher time 
// will turn you further around as will a higher turn speed.
$s::TurnAroundSpeed = 0.65;
$s::TurnAroundTime = 0.18;

$Favorite::lastFastFave = $sp::FastFave;

function s::buyFavs(%thefav)
{
	if(%thefav) {
		%favsav = $Favorite::lastFastFave;
		$Favorite::lastFastFave = %thefav;
	}

	// bought BEFORE armor
	%default1 = getItemType("Repair Kit");
	
	// bought AFTER armor
	%default2 = getItemType("Grenade") @ "," @ getItemType("Beacon") @ "," @ getItemType("Targeting Laser");

	%favorites =  %default1;
	if ((%cur = $Favorite::lastFastFave) != "")
	{
		if ($Favorite::fastFave[%cur, mines] != "")
			%default2 = %default2 @ "," @ getItemType("Mine");

		if ($Favorite::fastFave[%cur, armor] != "")
			%favorites = %favorites @ "," @ getItemType($Favorite::fastFave[%cur, armor]);

		if ($Favorite::fastFave[%cur, pack] != "")
			%favorites = %favorites @ "," @ getItemType($Favorite::fastFave[%cur, pack]);
					
		for (%i = 1; %i < 12; %i++)
		{
			if ((%weapon = $Favorite::fastFave[%cur, %i]) != "")
				%favorites = %favorites @ "," @ getItemType(%weapon);
		}			

		%favorites = %favorites @ "," @ %default2;
		eval("remoteEval(2048,buyFavorites," @ %favorites @ ");");
	}
	
	if(%thefav) {
		$Favorite::lastFastFave = %favsav;
	}
}

function s::ChangeAutoFav(%newfav)
{
	$Favorite::lastFastFave = %newfav;
	s::CenterPrint("<jc><f1>smalesHUD"@$s::Version@".favs -- set to buy: <f2>"@$Favorite::fastFave[%newfav,name], 2);
	event::Trigger(eventLoadoutChange);
}

function s::BuyThisFav(%fav)
{
	$Favorite::lastFastFave = %fav;
	if($Event::AtStation)
		s::buyFavs();
}

function s::SellEverything()
{
	sell("ammo pack");
	sell("energy pack");
	sell("repair pack");
	sell("sensor jammer pack");
	sell("shield pack");

	sell("ammo station");
	sell("inventory station");

	sell("blaster");
	sell("chaingun");
	sell("disc launcher");
	sell("elf gun");
	sell("grenade launcher");
	sell("laser rifle");
	sell("mortar");
	sell("plasma gun");
	sell("targeting laser");

	sell("camera");
	sell("motion sensor");
	sell("pulse sensor");
	sell("repair kit");
	sell("sensor jammer");
	sell("turret");	

	for(%i = 1; %i < 10; %i++) {
		sell("mine");
		sell("beacon");
		sell("grenade");
		sell("mine");
		sell("bullet");
		sell("Plasma Bolt");
		sell("Grenade Ammo");
		sell("Mortar Ammo");
		sell("Disc");
	}
}

function s::onEnterStation()
{
	pushActionMap("Favorite.sae");
	
	if($Event::Station == "Inventory") {
		if($sp::AutoRepair) {
			for(%i=0; %i<=6; %i++) {
				remoteEval(2048, useItem, 39);
				remoteEval(2048, buyItem, 39);
			}
		}
		// buy a scout if not in active mode because both vehicle and regular inventory stations
		// are called "Inventory" (we need to buy one to later check to make sure we should be
		// announcing our loudout or not)
		if(!$zAdmin::ActiveMode)
			buy("Scout");
	} else if($Event::Station == "RemoteInventory") {
		if($sp::AutoSellAll)
			s::SellEverything();
	} else if($Event::Station == "Vehicle") {
		buy("Scout");
	}
	
	if($sp::StationTurnAround) {
		postAction(2048, IDACTION_TURNLEFT, $s::TurnAroundSpeed);
		Schedule::Add("postAction(2048, IDACTION_TURNLEFT, -0);", $s::TurnAroundTime);
	}

	if($sp::ShowInvList)
		remoteEval(2048, ToggleInventoryMode);

	if($sp::ClusterSpew && (($Event::Station == "Inventory") || (($Event::Station == "RemoteInventory") && $sp::AutoSpewAtRemotes))) {
		Schedule::Add("s::dump(cluster, -1);", 0.1);
	}

	if($sp::AutoFavorites && (($Event::Station == "Inventory") || ($Event::Station == "RemoteInventory"))) {
		Schedule::Add("s::buyFavs();", 0.2);
	}
}

function s::onExitStation()
{		
	if($sp::AutoMsgAtStations && ($Event::ScoutCheck == 1)) {
		say(1, $sp::AutoFavMsgStart @ $Favorite::fastFave[$Favorite::lastFastFave,name]);
		$Event::ScoutCheck = 0;
	}
	popActionMap("Favorite.sae");
}

s::AddToggle(ShowInvList, "Inventory lists");
s::AddToggle(AutoFavorites, "Auto buy favorites");
s::AddToggle(AutoMsgAtStations, "Auto station loudout message");
s::AddToggle(ClusterSpew, "Auto cluster spew");
s::AddToggle(AutoRepair, "Auto buy/use 6 kits at stations");
s::AddToggle(AutoSellAll, "Auto sell-all at remote invens");
s::AddToggle(AutoSpewAtRemotes, "Auto cluster spew at remotes");
s::AddToggle(StationTurnAround, "Auto turn-around at stations");

event::Attach(eventEnterStation, s::onEnterStation);
event::Attach(eventExitStation, s::onExitStation);