function scorehud::Create()
{
	if($s::Huds[myScore]) {
		Hud::new("s_myScoreCont", $s::hud_myScore_X, $s::hud_myScore_Y, 45, 16, scorehud::Update, "", $sp::bgLevel);
		if($s::BitmapsOn) {
			newObject("s_myScoreBmp", FearGuiFormattedText, -2, 3, 0, 0);
			Control::setValue("s_myScoreBmp", "<B:features\\bmps\\score.bmp>");
			Hud::Add("s_myScoreCont", "s_myScoreBmp");
		}
		newObject("s_myScoreStr", FearGuiFormattedText, 11, -1, 0, 0);
		Hud::Add("s_myScoreCont", "s_myScoreStr");
	}
	
	scorehud::Reset();
}

function scorehud::Reset()
{
	$s::Score = 0;
	$s::Rating = 0;
}

function scorehud::Clear()
{
	scorehud::Reset();
	scorehud::Update();
}

function scorehud::Update()
{	
	if($sp::myScoreHudRatingMode)
		Control::setValue("s_myScoreStr", $sp::FontColor @ $s::Rating);
	else
		Control::setValue("s_myScoreStr", $sp::FontColor @ $s::Score);
}

function scorehud::onKillTrak(%killer, %victim, %weapon)
{
	if((%killer == getManagerID()) || (%victim == getManagerID()))
	{
		if(%weapon == "Suicide")
			$s::Score--;
		else if(Team::Friendly() != Client::getTeam(%victim))
			$s::Score++;
			
		$s::Rating = StatHUD::getRating(client::getName(getManagerID()));
		scorehud::Update();
	}
}

function scorehud::onFlagCaptured(%team, %name)
{
	$s::Score += 5;
	scorehud::Update();
}

function scorehud::onFlagUpdate()
{
	$s::Rating = StatHUD::getRating(client::getName(getManagerID()));
	scorehud::Update();
}

s::AddToggle(myScoreHudRatingMode, "ScoreHUD rating mode");

if($s::Huds[myScore]) {
	scorehud::Create();
	event::Attach(eventConnectionAccepted, scorehud::Clear);
	event::Attach(eventChangeMission, scorehud::Clear);
	event::Attach(eventKillTrak, scorehud::onKillTrak);
	event::Attach(eventFlagUpdate, scorehud::onFlagUpdate);
	event::Attach(eventFlagCaptured, scorehud::onFlagCaptured);
}