function teamhud::Create()
{
	if($s::Huds[teamF]) {
		Hud::new("s_TeamFCont", $s::hud_teamF_X, $s::hud_teamF_Y, 36, 16, teamhud::Update, "", $sp::bgLevel);
		if($s::BitmapsOn && $s::BitmapsTeamOn) {
			newObject("s_FTeamBmp", FearGuiFormattedText, 1, 3, 10, 10);
			Control::setValue("s_FTeamBmp", "<B:features\\bmps\\friendly.bmp>");
			Hud::Add("s_TeamFCont", "s_FTeamBmp");
		}
		newObject("s_FTeamStr", FearGuiFormattedText, 18, -1, 0, 0);
		Hud::Add("s_TeamFCont", "s_FTeamStr");
	}

	if($s::Huds[teamE]) {
		Hud::new("s_TeamECont", $s::hud_teamE_X, $s::hud_teamE_Y, 36, 16, teamhud::Update, "", $sp::bgLevel);
		if($s::BitmapsOn && $s::BitmapsTeamOn) {
			newObject("s_ETeamBmp", FearGuiFormattedText, 1, 3, 10, 10);
			Control::setValue("s_ETeamBmp", "<B:features\\bmps\\enemy.bmp>");
			Hud::Add("s_TeamECont", "s_ETeamBmp");
		}
		newObject("s_ETeamStr", FearGuiFormattedText, 18, -1, 0, 0);
		Hud::Add("s_TeamECont", "s_ETeamStr");
	}

	if($s::Huds[teamO]) {
		Hud::new("s_TeamOCont", $s::hud_teamO_X, $s::hud_teamO_Y, 36, 16, teamhud::Update, "", $sp::bgLevel);
		if($s::BitmapsOn && $s::BitmapsTeamOn) {
			newObject("s_OTeamBmp", FearGuiFormattedText, 1, 3, 10, 10);
			Control::setValue("s_OTeamBmp", "<B:features\\bmps\\observe.bmp>");
			Hud::Add("s_TeamOCont", "s_OTeamBmp");
		}
		newObject("s_OTeamStr", FearGuiFormattedText, 18, -1, 0, 0);
		Hud::Add("s_TeamOCont", "s_OTeamStr");
	}

	teamhud::Reset();
}

function teamhud::Reset()
{
	deleteVariables("$s::TeamCount*");

	$s::TeamCount[-1] = 0;
	$s::TeamCount[0] = 0;
	$s::TeamCount[1] = 0;
}

function teamhud::Update()
{
	Control::setValue("s_FTeamStr", $sp::FontColor @ $s::TeamCount[Team::Friendly()]);
	Control::setValue("s_ETeamStr", $sp::FontColor @ $s::TeamCount[Team::Enemy()]);
	Control::setValue("s_OTeamStr", $sp::FontColor @ $s::TeamCount[-1]);
}

function teamhud::onClientChangeTeam(%client, %team)
{
	$s::TeamCount[$s::TeamCountPlayerList[%client, team]]--;
	$s::TeamCountPlayerList[%client, team] = %team;
	$s::TeamCount[%team]++;

	teamhud::Update();
}

function teamhud::onClientJoin(%client)
{
	%team = Client::getTeam(%client);
	$s::TeamCount[%team]++;
	$s::TeamCountPlayerList[%client, team] = %team;

	teamhud::Update();
}

function teamhud::onClientDrop(%client)
{
	$s::TeamCount[$s::TeamCountPlayerList[%client, team]]--;
	
	teamhud::Update();
}

if($s::Huds[teamF] || $s::Huds[teamE] || $s::Huds[teamO]) {
	teamhud::Create();
	event::Attach(eventClientChangeTeam, teamhud::onClientChangeTeam);
	event::Attach(eventClientJoin, teamhud::onClientJoin);
	event::Attach(eventClientDrop, teamhud::onClientDrop);
	event::Attach(eventConnectionAccepted, teamhud::Reset);
}