// dont touch this
$s::sensNumModes = 2;

// The current sensitivity mode setting
$s::sensMode = 1;

function s::sensCycle()
{
	$s::sensMode = ($s::sensMode % $s::sensNumModes) + 1;
	
	s::sensSetMode($s::sensMode);
}

function s::sensSetMode(%mode)
{
	if(%mode == 1) {
		postAction(2048, IDACTION_MOVEUP, -0);
		s::SetSensitivity($sp::sensDefault, $sp::sensDefault);
		s::CenterPrint("<jc>Sensitivity = NORMAL", 1);		
	}
	else if(%mode == 2) {
		s::SetSensitivity($s::sensScoutX, $s::sensScoutY);
		s::CenterPrint("<jc>Sensitivity = SCOUT", 1);		
	}
	else if(%mode == 3) {
		s::SetSensitivity($s::sensSpazX, $s::sensSpazY);
		s::CenterPrint("<jc>Sensitivity = SPAZ", 1);
	}
}

function s::SetSensitivity(%xSens,%ySens)
{	
	EditActionMap("playMap.sae");
	if(Client::getMouseXaxisFlip("playMap.sae"))
		bindAction(mouse0, xaxis0, TO, IDACTION_YAW, Scale, %xSens);
	else
		bindAction(mouse0, xaxis0, TO, IDACTION_YAW, Flip, Scale, %xSens);
		
	EditActionMap("playMap.sae");
	if(Client::getMouseYaxisFlip("playMap.sae"))
		bindAction(mouse0, yaxis0, TO, IDACTION_PITCH, Scale, %ySens);
	else
		bindAction(mouse0, yaxis0, TO, IDACTION_PITCH, Flip, Scale, %ySens);
}

function s::sensitivityOnZoomIn()
{
	if($s::sensMode > 1)  return;
	
	// laser rifle
	if(getMountedItem(0) == 22)
	{
		%sensnew = $sp::sensDefault*$s::sensFactorZoomRifle;
		s::SetSensitivity(%sensnew, %sensnew);
	}
	else
	{
		%sensnew = $sp::sensDefault*$s::sensFactorZoom;
		s::SetSensitivity(%sensnew, %sensnew);
	}
}

function s::sensitivityOnZoomOut()
{
	if($s::sensMode > 1) return;
	
	s::SetSensitivity($sp::sensDefault, $sp::sensDefault);
}

function s::sensBaseIncrease()
{
	if($s::sensMode > 1) return;
	$sp::sensDefault += 0.000075;
	s::CenterPrint("<jc><f1>smalesHUD"@$s::Version@".sens -- base sensitivity: <f2>"@$sp::sensDefault, 2);
	s::SetSensitivity($sp::sensDefault, $sp::sensDefault);
}

function s::sensBaseDecrease()
{
	if($s::sensMode > 1) return;
	$sp::sensDefault -= 0.000075;
	if($sp::sensDefault < 0.000075) $sp::sensDefault = 0.000075;
	s::CenterPrint("<jc><f1>smalesHUD"@$s::Version@".sens -- base sensitivity: <f2>"@$sp::sensDefault, 2);
	s::SetSensitivity($sp::sensDefault, $sp::sensDefault);
}

function s::setBaseSensitivity()
{
	s::SetSensitivity($sp::sensDefault, $sp::sensDefault);
}

event::Attach(eventZoomIn, s::sensitivityOnZoomIn);
event::Attach(eventZoomOut, s::sensitivityOnZoomOut);
event::Attach(eventConnected, s::setBaseSensitivity);
event::Attach(eventEnterVehicle, "s::sensSetMode(2);");
event::Attach(eventExitVehicle, "s::sensSetMode(1);");