// editable
$s::spewDelay = 0.1;

// do not touch
$s::cycleSpot = 1;
$s::spewSpot = 0;
$s::spewBool = false;

function s::spewdrop(%item, %quan)
{
	if(%item == "Laser Rifle")
		buy("Light Armor");
			
	for(%cnt = 0; %cnt < %quan; %cnt++)
	{
		buy(%item);
		drop(%item);
	}
	
	if(%item == "Laser Rifle")
		buy("Heavy Armor");
}

function s::fountain(%fav)
{
	if($s::spewSpot) {
		%item = $s::spewQueue[$s::spewSpot];
		//echo("stream.spew -- spewed '"@%item@"' from spew queue at '"@$s::spewSpot@"'");
		s::spewdrop(%item, 1);
		$s::spewQueue[$s::spewSpot] = "";
	}
	$s::spewSpot--;
	if($s::spewSpot>0) {
 		schedule::add("s::fountain("@%fav@");", $s::spewDelay);
 	} else {
 		s::restoreItems(%fav);
 		schedule::add("$s::spewBool=false;", $s::spewDelay, "spew_killer");
 	}
}

function s::addtoqueue(%item, %quantity)
{
	%start = $s::spewSpot+1;
	%end = %quantity+%start;
	for(%c=%start;%c<%end;%c++) {
		$s::spewQueue[%c] = %item;
		//echo("stream.spew -- added '"@%item@"' to spew queue at '"@%c@"'");
	}
	$s::spewSpot = %end-1;
}

function s::cluster()
{
	for(%cnt=1;$s::item[%cnt]!="";%cnt++) {
		%item = $s::item[%cnt];
		%quan = $s::item[%cnt, %cnt];
		
		s::spewdrop(%item, %quan);
	}
}

function s::cycle()
{
	%item = $s::item[$s::cycleSpot];
	%quan = $s::item[$s::cycleSpot, $s::cycleSpot];

	s::spewdrop(%item, %quan);

	$s::cycleSpot = ($s::cycleSpot % $z);
	$s::cycleSpot++;
}                                  
                                  
function s::freeSlots()
{
	if(getItemCount("Light Armor"))
		$s::lastArmor = "Light Armor";
	else if(getItemCount("Medium Armor"))
		$s::lastArmor = "Medium Armor";
	else
		$s::lastArmor = "Heavy Armor";
                                
	if(getItemCount("Blaster"))
	{
		sell("Blaster");
		$s::freedWpn = "Blaster";
	}
	else if(getItemCount("Chaingun"))
	{
		sell("Chaingun");
		$s::freedWpn = "Chaingun";
	}
	else if(getItemCount("Disc Launcher"))
	{
		sell("Disc Launcher");
		$s::freedWpn = "Disc Launcher";
	}
	else if(getItemCount("Plasma Gun"))
	{
		sell("Plasma Gun");
		$s::freedWpn = "Plasma Gun";
	}
	else if(getItemCount("Grenade Launcher"))
	{
		sell("Grenade Launcher");
		$s::freedWpn = "Grenade Launcher";
	}
	else
		$s::freedWpn = "";
	
	$s::laserRifleOwned = getItemCount("Laser Rifle");
	buy("Heavy Armor");
}


function s::trackItems()
{
	if(getItemCount("energy pack")) 
	{
		$s::freedPack = "energy pack";
		return;
	}

	if(getItemCount("shield pack"))
	{
		$s::freedPack = "shield pack";
		return;
	}

	if(getItemCount("repair pack"))
	{
		$s::freedPack = "repair pack";
		return;
	}

	if(getItemCount("turret"))
	{
		$s::freedPack = "turret";
		return;
	}

	if(getItemCount("inventory station"))
	{
		$s::freedPack = "inventory station";
		return;
	}

	if(getItemCount("ammo pack"))
	{
		$s::freedPack = "ammo pack";
		return;
	}

	if(getItemCount("ammo station"))
	{
		$s::freedPack = "ammo station";
		return;
	}

	if(getItemCount("camera"))
	{
		$s::freedPack = "camera";
		return;
	}

	if(getItemCount("motion sensor"))
	{
		$s::freedPack = "motion sensor";
		return;
	}

	if(getItemCount("pulse sensor"))
	{
		$s::freedPack = "pulse sensor";
		return;
	}

	if(getItemCount("sensor jammer"))
	{
		$s::freedPack = "sensor jammer";
		return;
	}

	if(getItemCount("sensor jammer pack"))
	{
		$s::freedPack = "sensor jammer pack";
		return;
	}

	$s::freedPack = "";
}

function s::restoreItems(%fav)
{	
	if(%fav == -1) {
		if(getItemCount("Light Armor")==0)
			buy($s::lastArmor);
		if(($s::freedPack != "") && (getItemCount($s::freedPack)==0))
			buy($s::freedPack);
		if(($s::freedWpn != "") && (getItemCount($s::freedWpn)==0))
			buy($s::freedWpn);
		if($s::laserRifleOwned && (getItemCount("Laser Rifle")==0))
			buy("Laser Rifle");
	} else {
		s::buyFavs(%fav);
	}
}

function s::dump(%option, %fav, %item, %quantity)
{
	if($s::spewBool) {
		%reboot = schedule::check("spew_killer");
		if(%reboot)
			schedule::add("s::dump("@%option@","@%fav@",\""@%item@"\","@%quantity@");", $s::spewDelay);
		else
			s::addtoqueue(%item,%quantity);
		return;
	}

	s::trackItems();

	s::freeSlots();

	if(%option == cycle) {
  	s::cycle();
	} else if(%option == cluster) {
    s::cluster();
	} else if(%option == single) {
		s::addtoqueue(%item, %quantity);
		s::fountain(%fav);
		$s::spewBool=true;
		return;
	}

	s::restoreItems(%fav);
}