Event::Attach(eventClientJoin, StatHUD::playerActivityTimestamp);

Event::Attach(eventMatchStarted, StatHUD::playerTimestampReset);

Event::Attach(eventKillTrak, StatHud::Kill);

Event::Attach(eventFlagTaken, StatHUD::GenericFlag);
Event::Attach(eventFlagReturned, StatHUD::GenericFlag);
Event::Attach(eventFlagCaptured, StatHUD::GenericFlag);
Event::Attach(eventFlagDropped, StatHUD::GenericFlag);

$StatHud::WeaponList[0] = "Chaingun";
$StatHud::WeaponList[1] = "Plasma";
$StatHud::WeaponList[2] = "Disc Launcher";
$StatHud::WeaponList[3] = "Explosives";
$StatHud::WeaponList[4] = "Laser Rifle";
$StatHud::WeaponList[5] = "Mortar";
$StatHud::WeaponList[6] = "Blaster";
$StatHud::WeaponList[7] = "Elf Gun";
$StatHud::WeaponList[8] = "Vehicle";

$StatHud::WeaponList[count] = 9;

// get a players rating
//

function StatHud::getRating(%name)
{
	%rating = 	($MapLogger::Kills[%name, Chaingun] 		* $StatHUD::Rating["l_chainkill"]) +
				($MapLogger::Kills[%name, "Disc Launcher"]	* $StatHUD::Rating["l_disckill"]) +
				($MapLogger::Kills[%name, Blaster] 			* $StatHUD::Rating["l_blasterkill"]) +
				($MapLogger::Kills[%name, Plasma] 			* $StatHUD::Rating["l_plasmakill"]) +
				($MapLogger::Kills[%name, Explosives] 		* $StatHUD::Rating["l_explokill"]	) +
				($MapLogger::Kills[%name, "Laser Rifle"] 	* $StatHUD::Rating["l_laserkill"]) +
				($MapLogger::Kills[%name, "Elf Gun"] 		* $StatHUD::Rating["l_elfkill"]) +
				($MapLogger::Kills[%name, Vehicle] 			* $StatHUD::Rating["l_vehickill"]) +
				($MapLogger::Kills[%name, Mortar] 			* $StatHUD::Rating["l_mortarkill"]) +
				($MapLogger::Suicides[%name] 				* $StatHUD::Rating["l_suicide"]) +
				(($MapLogger::TeamKills[%name] + 
                  $MapLogger::TeamMineKills[%name]) 		* $StatHUD::Rating["l_tk"]) +
				($MapLogger::CarrierKills[%name]			* $StatHUD::Rating["l_carrierkill"]) +
				($MapLogger::Grabs[%name] 					* $StatHUD::Rating["l_grabs"] ) +
				($MapLogger::Pickups[%name] 				* $StatHUD::Rating["l_pickups"] ) +
				($MapLogger::Drops[%name] 					* $StatHUD::Rating["l_drops"] ) +
				($MapLogger::Returns[%name] 				* $StatHUD::Rating["l_flagreturns"] ) +
				(($MapLogger::standoffReturn[%name] +
				  $MapLogger::capSave[%name])				* $StatHUD::Rating["l_standoff"] ) +
				($MapLogger::Assists[%name] 				* $StatHUD::Rating["l_assists"] ) +
				($MapLogger::Caps[%name] 					* $StatHUD::Rating["l_caps"] ) +
				($MapLogger::Deaths[%name, Mortar] 			* $StatHUD::Rating["l_mortardeath"] ) +
				((	$MapLogger::Deaths[%name, Chaingun] +
					$MapLogger::Deaths[%name, "Disc Launcher"] +
					$MapLogger::Deaths[%name, Blaster] +
					$MapLogger::Deaths[%name, Plasma] +
					$MapLogger::Deaths[%name, Explosives] +
					$MapLogger::Deaths[%name, "Laser Rifle"] +
					$MapLogger::Deaths[%name, "Elf Gun"] +
					$MapLogger::Deaths[%name, Vehicle]) 	* $StatHUD::Rating["l_otherdeath"] );

	return %rating;
}

// our kill functions, triggers a stat update
//

function StatHud::Kill(%killer, %victim, %weapon)
{
	StatHUD::playerActivityTimestamp(%killer);
	StatHUD::playerActivityTimestamp(%victim);

	// update stat sheet
	if ($StatHUD::StatSheetVisible)
		StatHUD::ShowPlayers();
		
	//ez out
	return;
}

// our flag functions, triggers a stat update

function StatHUD::GenericFlag(%team, %client)
{
	StatHUD::playerActivityTimestamp(%client);

	// update stat sheet
	if ($StatHUD::StatSheetVisible)
		StatHUD::ShowPlayers();
		
	//ez out
	return;
}

function StatHUD::playerTimestampReset()
{
	for (%i = 2049; %i < 2150; %i++)
	{
		StatHUD::playerActivityTimestamp(%i);
	}
}

function StatHUD::playerActivityTimestamp(%client)
{
	$StatHUD::PlayerTimeStamp[%client] = getSimTime();
}


// ********************************************************************************************************************
//
// INGAME STAT SHEET STUFF
//


// load all the players currently in the server

function StatHUD::LoadPlayerStats()
{
	stack::freeze("playerlist");

	$StatHUD::PlayerCount[-1] = 0;
	$StatHUD::PlayerCount[0] = 0;
	$StatHUD::PlayerCount[1] = 0;

	stack::reset("playerlist");
	for (%i = 0; %i < stack::count("playerlist"); %i++)
	{
		%name = stack::getnext("playerlist");
		
		if ((%clientid = getClientByName(%name)) != 0)
		{
			%team = client::getteam(%clientid);

			$StatHUD::DisplayList[ %team, $StatHUD::PlayerCount[%team] ] = %name;

			$StatHUD::PlayerList[%name, kills] = $MapLogger::Kills[%name];
			$StatHUD::PlayerList[%name, deaths] = $MapLogger::Deaths[%name];
			$StatHUD::PlayerList[%name, rating] = StatHud::getRating(%name);
			$StatHUD::PlayerList[%name, disckills] = $MapLogger::Kills[%name, "Disc Launcher"];
			$StatHUD::PlayerList[%name, discdeaths] = $MapLogger::Deaths[%name, "Disc Launcher"];
			$StatHUD::PlayerList[%name, mortarkills] = $MapLogger::Kills[%name, "Mortar"];
			$StatHUD::PlayerList[%name, mortardeaths] = $MapLogger::Deaths[%name, "Mortar"];
			$StatHUD::PlayerList[%name, chainkills] = $MapLogger::Kills[%name, "Chaingun"];
			$StatHUD::PlayerList[%name, chaindeaths] = $MapLogger::Deaths[%name, "Chaingun"];
			$StatHUD::PlayerList[%name, explokills] = $MapLogger::Kills[%name, "Explosives"];
			$StatHUD::PlayerList[%name, explodeaths] = $MapLogger::Deaths[%name, "Explosives"];
			$StatHUD::PlayerList[%name, laserkills] = $MapLogger::Kills[%name, "Laser Rifle"];
			$StatHUD::PlayerList[%name, laserdeaths] = $MapLogger::Deaths[%name, "Laser Rifle"];
			$StatHUD::PlayerList[%name, suicides] = $MapLogger::Suicides[%name];
			if ($MapLogger::CarrierKills[%name])
				$StatHUD::PlayerList[%name, carrierkills] = $MapLogger::CarrierKills[%name];
			else
				$StatHUD::PlayerList[%name, carrierkills] = "0";
			$StatHUD::PlayerList[%name, touches] = $MapLogger::Grabs[%name] + $MapLogger::Pickups[%name];
			if ($MapLogger::Returns[%name])
				$StatHUD::PlayerList[%name, returns] = $MapLogger::Returns[%name];
			else
				$StatHUD::PlayerList[%name, returns] = "0";
			$StatHUD::PlayerList[%name, pickups] = $MapLogger::Pickups[%name];
			$StatHUD::PlayerList[%name, tks] = $MapLogger::TeamKills[%name] + $MapLogger::TeamMineKills[%name];
			$StatHUD::PlayerList[%name, idletime] = StatHUD::StopWatch(getSimTime() - $StatHUD::PlayerTimeStamp[%clientid]);
			if ($MapLogger::grabs[%name])
				$StatHUD::PlayerList[%name, grabs] = $MapLogger::grabs[%name];
			else
				$StatHUD::PlayerList[%name, grabs] = "0";
			if ($MapLogger::assists[%name])
				$StatHUD::PlayerList[%name, assists] = $MapLogger::assists[%name];
			else
				$StatHUD::PlayerList[%name, assists] = "0";
			if ($MapLogger::caps[%name])
				$StatHUD::PlayerList[%name, caps] = $MapLogger::caps[%name];
			else
				$StatHUD::PlayerList[%name, caps] = "0";

			//echo ("sup: " @ getSimTime() @ " : " @ $StatHUD::PlayerTimeStamp[%clientid]);

			$StatHUD::PlayerCount[%team]++;
		}
	}

	stack::unfreeze("playerlist");
}

// sort the players stats using a gay bubble sort

function StatHUD::SortPlayerStats(%column)
{
	for (%team = -1; %team < 2; %team++)
	{
		for (%i = 0; %i < $StatHUD::PlayerCount[%team]-1; %i++)
		{
			for (%j = %i+1; %j < $StatHUD::PlayerCount[%team]; %j++)
			{
				%name[i] = $StatHUD::DisplayList[ %team, %i ];
				%name[j] = $StatHUD::DisplayList[ %team, %j ];

				if ($StatHUD::PlayerList[%name[i], %column] < $StatHUD::PlayerList[%name[j], %column])
				{
					%temp = $StatHUD::DisplayList[ %team, %i ];
					$StatHUD::DisplayList[ %team, %i ] = $StatHUD::DisplayList[ %team, %j ];
					$StatHUD::DisplayList[ %team, %j ] = %temp;
				}
			}
		}
	}
}

// tab width in pixels
$StatHUD::Spacer = "\t";
$StatHUD::SpacerWidth = $String::TabPixels;

// column widths in terms of our spacer
$StatHUD::headerPixelSize[0] = 12 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[1] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[2] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[3] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[4] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[5] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[6] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[7] = 3 * $StatHUD::SpacerWidth;
$StatHUD::headerPixelSize[8] = 4 * $StatHUD::SpacerWidth;


// set up the a kill/death item correctly
//

function StatHUD::KillDeathLine(%kills, %deaths)
{
	if (%kills == "")
		%kills = 0;
	if (%deaths == "")
		%deaths = 0;

	return %kills @ "/" @ %deaths;
}

function StatHUD::KillTrio(%dk, %ck, %xk)
{
	if (%dk == "")
		%dk = 0;
	if (%ck == "")
		%ck = 0;
	if (%xk == "")
		%xk = 0;

	return %dk @ "/" @ %ck @ "/" @ %xk;
}

// tab an item apprioately for its column
//

function StatHUD::TabItem(%index, %text)
{
	%textPixels = String::Pixels(%text);
	%columnPixels = $StatHUD::headerPixelSize[%index];

	// we are assuming the text width will never surpass the column
	%pixelDifference = %columnPixels - %textPixels;
	%tabsRequired = floor((%pixelDifference / $StatHUD::SpacerWidth) + 1);
	
	//echo(%pixelDifference);

	if (%index == 0)
		%text = String::EscapeTags(%text);

	for (%i = 0; %i < %tabsRequired; %i++)
	{
		%text = %text @ "\t";
	}

	return %text;
}

// output a line of tabed items
//

function StatHUD::TabbedList(%item0, %item1, %item2, %item3, %item4, %item5, %item6, %item7, %item8, %item9, %item10)
{
	%list = "\t\t\t\t";

	for (%i = 0; %i < 9; %i++)
	{
		%list = %list @ StatHUD::TabItem(%i, %item[%i]);
	}

	%list = %list @ "\n";

	return %list;
}


// display the player stats
//

function StatHUD::ShowPlayerStats()
{
	%topLine = "<f1>" @ StatHUD::TabbedList("Name", "Rat", "K/D", "CKs", "Caps", "Asst", "Grabs", "Rets", "D/C/X");
	%lines[count] = 1;
	%lines[all] = 0;
	for (%team = 1; %team > -2; %team--)
	{
		//divider between teams
		if(($StatHUD::PlayerCount[%team] > 0) && (%lines[all] < 22)) {
			%teamname = $Team::Name[%team+1];
			if(%teamname == "unnamed") %teamname = "Observers";
			%topLine = %topLine @ "\n\t\t<f1>" @ %teamname @ ":\n";
			%lines[count]++;
			%lines[count]++;
		}
		
		%lines[%team] = 0;
		for (%i = 0; %i < $StatHUD::PlayerCount[%team] ; %i++)
		{
			%name = $StatHUD::DisplayList[ %team, %i ];

			if ((%lines[%team] < 10) && (%lines[all] < 22))
			{
				if(%name == client::getName(getManagerID())) %color = "<f0>";
				else %color = "<f2>";

				%topLine = %topLine @ %color @
					StatHUD::TabbedList(%name,
					$StatHUD::PlayerList[%name, rating],
					StatHUD::KillDeathLine($StatHUD::PlayerList[%name, kills],$StatHUD::PlayerList[%name, deaths]),
					$StatHUD::PlayerList[%name, carrierkills],
					$StatHUD::PlayerList[%name, caps],
					$StatHUD::PlayerList[%name, assists],
					$StatHUD::PlayerList[%name, grabs],
					$StatHUD::PlayerList[%name, returns],
					StatHUD::KillTrio($StatHUD::PlayerList[%name, disckills], $StatHUD::PlayerList[%name, chainkills], $StatHUD::PlayerList[%name, explokills]));

				%lines[%team]++;
				%lines[all]++;
				%lines[count]++;
			}
		}
	}

	remoteCP(2048, %topLine, 100);
}

// show the player top level function

function StatHUD::ShowPlayers()
{
	$StatHUD::StatSheetVisible = TRUE;

	StatHUD::LoadPlayerStats();
	StatHUD::SortPlayerStats("rating");
	StatHUD::ShowPlayerStats();
}

// hide the players

function StatHUD::HidePlayers()
{
	$StatHUD::StatSheetVisible = FALSE;

	remoteCP(2048, '', 0);
}

$String::asciiString = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";

function StatHUD::StopWatch(%time)
{
	if (%time < 0)
	{
		%time = 0;
	}

	%minutes = floor(%time / 60);
	%seconds = %time % 60;

	%TimeString = %minutes @ ":";

	if (%Seconds < 10)
		%TimeString = %TimeString @ "0";

	return %TimeString @ %seconds;
}
