$s::converts[DeployableInvPack] = 27;
$s::converts[DeployableAmmoPack] = 28;
$s::converts[EnergyPack] = 29;
$s::converts[RepairPack] = 30;
$s::converts[ShieldPack] = 31;
$s::converts[SensorJammerPack] = 32;
$s::converts[MotionSensorPack] = 33;
$s::converts[AmmoPack] = 34;
$s::converts[PulseSensorPack] = 35;
$s::converts[DeployableSensorJammerPack] = 36;
$s::converts[CameraPack] = 37;
$s::converts[TurretPack] = 38;

function use(%desc)
{
	%type = getItemType(%desc);
	if (%type != -1)
	{
		useItem(%type);
		Event::Trigger(eventUseItem, %type);
	}
}

function throw(%desc)
{
	%type = getItemType(%desc);
	if (%type != -1)
	{
		remoteEval(2048, throwItem, %type, 1000);
		Event::Trigger(eventUseItem, %type);
	}
}

function remoteINV(%msg) 
{ 
	if(String::findSubStr(%msg, "STATION ENERGY") != -1) 
		$Event::Station = "RemoteInventory";
	else 
		$Event::Station = "Inventory";
}

function remoteITXT(%manager, %msg) 
{
	if(%manager == 2048) 
	{ 
		Control::setValue(EnergyDisplayText, %msg);
		if(!$zAdmin::ActiveMode)
			remoteINV(%msg);
	} 
}

function onVehicleEnter()
{
	event::Trigger(eventEnterVehicle);
}

function onVehicleExit()
{
	event::Trigger(eventExitVehicle);
}

function onClientMessage(%client, %msg)
{
	//echo("CLIENT MESSAGE: "@%msg);
	if(%client) {
		if(%client == getManagerID())
			return true;
		else
			return event::Trigger(eventClientMessage, %client, %msg);
	}

	if(!$zAdmin::ActiveMode) {
		if(string::FindSubStr(%msg, "flag") != -1) {
			s::flagEvents(%msg);
			return event::Trigger(eventServerMessage, %msg);
		}
		else if(%msg == "Station Access On") {
			$Event::ScoutCheck = 0;
			$Event::AtStation = "TRUE";
			event::Trigger(eventEnterStation, %msg);
			return false;
		}
		else if(%msg == "Station Access Off") {
			$Event::AtStation = "FALSE";
			event::Trigger(eventExitStation, %client, %msg);
			return false;
		}
		else if(String::FindSubStr(%msg, "couldn't buy Scout") != -1) {
			$Event::ScoutCheck = 1;
			return false;
		}
		else if(string::findSubStr(%msg, "You received ") != -1) {
			%substr = String::getSubStr(%msg, 13, 1024);
			%space = String::findSubStr(%substr, " ");
			%count = String::getSubStr(%substr, 0, %space);
			%item = String::getSubStr(%substr, %space+1, 1024);
			%nextspace = string::findSubStr(%item, " ");
			if(%nextspace > -1) {
				%lastword = string::getSubStr(%item, %nextspace+1, 1024);
				if(%lastword == "backpack")
					%item = string::getSubStr(%item, 0, %nextspace);
			}
			//echo("--ITEM PICKUP: "@%item);
			%type = getItemType(%item);
			if(%type == -1)
				%type = $s::converts[%item];
			event::Trigger(eventItemReceived, %type, %count);
			return true;
		}
		else if(%msg == "Match started.") {
			event::Trigger(eventMatchStarted);
			return true;
		}
	}
	
	if(String::FindSubStr(%msg, "deployed") != -1)
		return event::Trigger(eventDeployed,%msg);

	if(String::getSubStr(%msg, 0, 6) == "Repair")
		return event::Trigger(eventRepairing,%msg);
	
	if(string::FindSubStr(%msg, "You couldn't buy ") != -1)
		return false;
		
	if(string::FindSubStr(%msg, "buysell") != -1)
		return false;
  
	return event::Trigger(eventServerMessage, %msg);
}

function s::flagEvents(%msg)
{
	%event = FALSE;
	
	if((%idx = String::FindSubStr(%msg, " took the")) != -1) 
	{
		$Flag::Name = String::GetSubStr(%msg, 0, %idx); 
		if($Flag::Name == "You") 
			$Flag::Name = Client::getName(getManagerId());
		$Flag::NameID = getClientByName($Flag::Name);
		$Flag::Team = Client::GetTeam($Flag::NameID) ^ 1;
		
		%event = "EventFlagTaken";	
	}
	else if ((%idx = String::FindSubStr(%msg, " dropped the")) != -1) 
	{
		$Flag::Name = String::GetSubStr(%msg, 0, %idx); 
		if($Flag::Name == "You") 
			$Flag::Name = Client::getName(getManagerId());
		$Flag::NameID = getClientByName($Flag::Name);
		$Flag::Team = Client::GetTeam($Flag::NameID) ^ 1;

		%event = "EventFlagDropped";
	}
	else if((%idx = String::FindSubStr(%msg, " returned the")) != -1) 
	{
		$Flag::Name = String::GetSubStr(%msg, 0, %idx); 
		if($Flag::Name == "You") 
			$Flag::Name = Client::getName(getManagerId());
		$Flag::NameID = getClientByName($Flag::Name);
		$Flag::Team = Client::GetTeam($Flag::NameID);
		$Event::SkipReturn = true;

		%event = "EventFlagReturned";
	}
	else if((%idx = String::FindSubStr(%msg, " flag was returned to")) != -1)
	{
		if($Event::SkipReturn) {
			$Event::SkipReturn = false;
			return false;
		}
		if(string::findSubStr(%msg, "~w") == -1) sound("flagreturn.wav");
		$Flag::Team = string::getSubStr(%msg, 0, %idx);
		if(string::findSubStr($Flag::Team, "Your") != -1) {
			$Flag::Team = Client::GetTeam(getManagerID());
		} else {
			if(string::findSubStr($Flag::Team, $Team::Name[0]) != -1)
				$Flag::Team = 0;
			else
				$Flag::Team = 1;
		}
		$Flag::NameID = -1;
		
		%event = "EventFlagReturned";
	}
	else if((%idx = String::FindSubStr(%msg, " captured the")) != -1) 
	{
		$Flag::Name = String::GetSubStr(%msg, 0, %idx); 
		if($Flag::Name == "You") 
			$Flag::Name = Client::getName(getManagerId());
		$Flag::NameID = getClientByName($Flag::Name);
		$Flag::Team = Client::GetTeam($Flag::NameID) ^ 1;

		if ($Flag::Name == "Your Team")
			return;

		%event = "EventFlagCaptured";
	}
	else if((%idx = String::FindSubStr(%msg, " left the mission")) != -1) 
	{
		$Flag::Name = String::GetSubStr(%msg, 0, %idx); 
		if($Flag::Name == "You") 
			$Flag::Name = Client::getName(getManagerId());
		$Flag::NameID = getClientByName($Flag::Name);
		$Flag::Team = Client::GetTeam($Flag::NameID) ^ 1;
		%event = "EventFlagReturned";
	}

	if (($Flag::NameID == 0) || (%event == FALSE))
	{
		return false;
	}
	else
	{
		//echo("--"@%event@"-"@$Flag::Team@"-"@$Flag::NameID);
		event::Trigger(%event, $Flag::Team, $Flag::NameID);

		//Trigger a generic Flag event
		event::Trigger(EventFlagUpdate);
		return true;
	}
}


function onTeamAdd(%team, %name)
{
	Event::Trigger(eventClientTeamAdd, %team, %name);
}

function onClientChangeTeam(%client, %team)
{	
	Event::Trigger(eventClientChangeTeam, %client, %team);
}

function onClientDrop(%client)
{
	Event::Trigger(eventClientDrop, %client);
}

function onClientJoin(%client)
{
	Event::Trigger(eventClientJoin, %client);
}

function onExit()
{
	if($ConnectedToServer)
		disconnect();

	%returned = event::Trigger(eventExit);

	if(isObject(playGui))
		storeObject(playGui, "config\\play.gui");

	saveActionMap("config\\config.cs", "actionMap.sae", "playMap.sae", "pdaMap.sae");

	// update the video mode - since it can be changed with alt-enter
	$pref::VideoFullScreen = isFullScreenMode(MainWindow);

	checkMasterTranslation();
	echo("exporting pref::* to prefs.cs");
	export("pref::*", "config\\ClientPrefs.cs", False);
	export("Server::*", "config\\ServerPrefs.cs", False);
	export("pref::lastMission", "config\\ServerPrefs.cs", True);
}

function onQuit()
{
	%returned = Event::Trigger(eventQuit);

	if(%returned == mute)
		return;

	if($pref::ConfirmQuit && !(%returned != noconfirm))
		GuiPushDialog(MainWindow, "gui\\Exit.gui");
	else
		quit();
}

function onConnection(%message)
{
	echo("Connection ", %message); 
	$dataFinished = false;
	
	if(%message == "Accepted") {
		resetSimTime();
		// execute the custom script
		if($PCFG::Script != "")
			exec($PCFG::Script);

		resetPlayDelegate();
		remoteEval(2048, "SetCLInfo", $PCFG::SkinBase, $PCFG::RealName, $PCFG::EMail, $PCFG::Tribe, $PCFG::URL, $PCFG::Info, $pref::autoWaypoint, $pref::noEnterInvStation, $pref::messageMask);

		if ($Pref::PlayGameMode == "JOIN") {
			cursorOn(MainWindow);
			GuiLoadContentCtrl(MainWindow, "gui\\Loading.gui");
			renderCanvas(MainWindow);
		}
		$Event::AtStation = "FALSE";
		event::Trigger(eventConnectionAccepted);
	} else if(%message == "Rejected") {
		Quickstart();
		$errorString = "Connection to server rejected:\n" @ $errorString;
		//GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");  // z0dd: dont need this when we're using auto-join
		schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		event::Trigger(eventConnectionRejected, $errorString);
 	} else {
		// startMainMenuScreen();
		Quickstart();
		if(%message == "Dropped") {
			if($errorString == "")
				$errorString = "Connection to server lost:\nServer went down.";
			else
				$errorString = "Connection to server lost:\n" @ $errorString;
			
			event::Trigger(eventConnectionLost, $errorString);
			GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
			schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		} else if(%message == "TimedOut") {
			$errorString = "Connection to server timed out.";
			event::Trigger(eventConnectionLost, $errorString);
			GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
			schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
		}
	}
}

//mute this
function onConnectionError(%client, %manager, %errorString)
{
	return;

	//if(%manager == 2048)
	//{
	//}
	//else
	//{
	//	Quickstart();
	//	GuiPushDialog(MainWindow, "gui\\MessageDialog.gui");
	//	$errorString = "Connection to server error:\n" @ %errorString;
	//	schedule("Control::setValue(MessageDialogTextFormat, $errorString);", 0);
	//}
}

function dataFinished()
{
	// called on client when all the dynamic data has finished transfer

	if ($cdMusic && !$pref::userCDOverride) {
		rbSetPlayMode(CD, 0);
		rbStop(CD);
	}

	$dataFinished = true;
	remoteEval(2048, dataFinished);

	Event::Trigger(eventConnected);

	echo("Flushing Texture Cache");
	flushTextureCache();
}

function EndGame()
{
	$ConnectedToServer = FALSE;
	$recordDemo = FALSE;

	setCursor(MainWindow, "Cur_Arrow.bmp");
	disconnect();

	if ($SinglePlayer)
		TrainingEndGameCallback();

	if ($pref::userCDOverride == False)
	{
		rbSetPlayMode (CD, 0);
		rbStop (CD);
		$cdTrack = "";
	}

	startMainMenuScreen();

	deleteServer();
	QuickStart();

	Event::Trigger(eventDisconnected);

	deleteObject(ConsoleScheduler);
	newObject(ConsoleScheduler, SimConsoleScheduler);
	
	if($quitOnDisconnect)
		schedule("quit();", 0);
}

function remoteMissionChangeNotify(%serverManagerId, %nextMission)
{
	if(%serverManagerId == 2048) {
		echo("Server mission complete - changing to mission: ", %nextMission);
		echo("Flushing Texture Cache");
		flushTextureCache();
		schedule("purgeResources(true);", 3);
		$Event::AtStation = "FALSE";
		Event::Trigger(eventChangeMission, %nextMission);
	}
}

// eventMissionInfo(%server, %missionName, $ServerMissionType)
function remoteMInfo(%server, %missionName)
{
	if(%server == 2048)
	{
		$MDESC::Type = "";
		$MDESC::Text = "";

		%file = "missions\\" @ %missionName @ ".dsc";
		if(File::findFirst(%file) != "")
			exec(%file);

		$ServerMission = %missionName;
		$ServerText = $MDESC::Text;
		$ServerMissionType = $MDESC::Type;

		if(isObject(LobbyGui))
			LobbyGui::onOpen();  // update lobby screen text.
	}

	Event::Trigger(eventMissionInfo, %server, %missionName, $ServerMissionType);
}

// eventServerInfo(%server, %version, %hostname, %mod, %info, %favKey)
function remoteSVInfo(%server, %version, %hostname, %mod, %info, %favKey)
{
	if(%server == 2048)
	{
		$ServerVersion = %version;
		$ServerName = %hostname;
		$modList = %mod;
		$ServerMod = $modList;
		$ServerInfo = %info;
		$ServerFavoritesKey = %favKey;

		Event::Trigger(eventServerInfo, %server, %version, %hostname, %mod, %info, %favKey);
		EvalSearchPath();
	}
}


function loadPlayGui()
{
	if(File::FindFirst("play.gui") != "")
	{
		GuiLoadContentCtrl(MainWindow, "play.gui");
	}
	else
	{
		GuiLoadContentCtrl(MainWindow, "gui\\play.gui");
	}

	if($PlayGUI::isLoaded == 0)
	{
		Event::Trigger(eventLoadPlayGui);
		$PlayGUI::isLoaded = 1;
	}
}

function PlayGui::onOpen()
{
	Event::Trigger(eventGuiOpen, playGui);
}

function PlayGui::onClose()
{
	Event::Trigger(eventGuiClose, playGui);
}

function CmdInventoryGui::onOpen()
{
	if($curFavorites == -1)
	{
		CmdInventoryGui::favoritesSel(1);
		Control::performClick("FavButton1");
	}

	event::Trigger(eventGuiOpen, CmdInventoryGui);
}


function CmdInventoryGui::onClose()
{
	Event::Trigger(eventGuiClose, CmdInventoryGui);
}

function CommandGui::onOpen()
{
	//initialize the commander buttons
	if ($pref::mapFilter & 0x0001) Control::setValue(IDCTG_CMDO_PLAYERS, "TRUE");
	else Control::setValue(IDCTG_CMDO_PLAYERS, "FALSE");

	if ($pref::mapFilter & 0x0002) Control::setValue(IDCTG_CMDO_TURRETS, "TRUE");
	else Control::setValue(IDCTG_CMDO_TURRETS, "FALSE");

	if ($pref::mapFilter & 0x0004) Control::setValue(IDCTG_CMDO_ITEMS, "TRUE");
	else Control::setValue(IDCTG_CMDO_ITEMS, "FALSE");

	if ($pref::mapFilter & 0x0008) Control::setValue(IDCTG_CMDO_OBJECTS, "TRUE");
	else Control::setValue(IDCTG_CMDO_OBJECTS, "FALSE");

	if (String::ICompare($pref::mapSensorRange, "TRUE") == 0) Control::setValue(IDCTG_CMDO_RADAR, "TRUE");
	else Control::setValue(IDCTG_CMDO_RADAR, "FALSE");

	if (String::ICompare($pref::mapNames, "TRUE") == 0) Control::setValue(IDCTG_CMDO_EXTRA, "TRUE");
	else Control::setValue(IDCTG_CMDO_EXTRA, "FALSE");

	Control::setValue("TVButton", false);

	Event::Trigger(eventGuiOpen, CommandGui);
}

function CommandGui::onClose()
{
	Event::Trigger(eventGuiClose, CommandGui);
}

function OptionsGui::onOpen()
{
	IRCOptions::init();

	OptionsMovement::init();
	OptionsVideo::init();
	OptionsGraphics::init();
	OptionsNetwork::init();
	OptionsSound::init();

	Event::Trigger(eventGuiOpen, OptionsGui);
}

function OptionsGui::onClose()
{
	Event::Trigger(eventGuiClose, OptionsGui);

	IRCOptions::Shutdown();

	OptionsNetwork::shutdown();
}

function CmdObjectivesGui::onOpen()
{
	Event::Trigger(eventGuiOpen, CmdObjectivesGui);
}

function CmdObjectivesGui::onClose()
{
	event::Trigger(eventGuiClose, CmdObjectivesGui);
}

function JoinGame()
{
	Event::Trigger(eventJoinGame);

	if ($IRC::DisconnectInSim == "")
		$IRC::DisconnectInSim = true;

	//disconnect from IRC if req'd
	if ($IRC::DisconnectInSim == true)
	{
	ircDisconnect();
	$IRCConnected = FALSE;
	$IRCJoinedRoom = FALSE;
	}
	//load the "connecting" gui
	GuiLoadContentCtrl(MainWindow, "gui\\Connecting.gui");

	$SinglePlayer = False;
	purgeResources();
	connect($Server::Address);
}

editActionMap("PlayMap.sae");
bindCommand(keyboard0, make, alt, "tab", TO, "Event::Trigger(EventAltTabPressed);");
bindCommand(keyboard0, make, alt, "enter", TO, "Event::Trigger(EventAltEnterPressed);");
bindCommand(keyboard0, make, control, "escape", TO, "Event::Trigger(EventControlEscapePressed);");

//--------------------------------------------
//
// these are all the functions called by the 
// server. they will only be called if you
// report to the server that you are in active
// mode
//	
//--------------------------------------------
function remoteEnterStation(%client, %station)
{
	$Event::Station = %station;
	$Event::AtStation = "TRUE";
	event::Trigger(EventEnterStation, %station);
}

function remoteExitStation(%client, %station)
{	
	if(%station == Vehicle)
		$Event::ScoutCheck = 0;
	else
		$Event::ScoutCheck = 1;
	$Event::AtStation = "FALSE";
	event::Trigger(EventExitStation, %station);
}

function remoteTeamScore(%client, %team, %score)
{
	event::Trigger(eventTeamScore, %team, %score);
}

function remoteItemReceived(%client, %item, %count)
{
	%type = getItemType(%item);
	if(%type == -1)
		%type = $s::converts[%item];
	event::Trigger(EventItemReceived, %type, %count);
}

function remoteMatchStarted(%client)
{
	event::Trigger(eventMatchStarted);
}

function remoteFlagTaken(%client, %team, %player)
{
	event::Trigger(eventFlagTaken, %team, %player);
	event::Trigger(eventFlagUpdate);
}

function remoteFlagDropped(%client, %team, %player)
{
	event::Trigger(eventFlagDropped, %team, %player);
	event::Trigger(eventFlagUpdate);
}

function remoteFlagReturned(%client, %team, %player)
{
	event::Trigger(eventFlagReturned, %team, %player);
	event::Trigger(eventFlagUpdate);
}

function remoteFlagCaptured(%client, %team, %player)
{
	event::Trigger(eventFlagCaptured, %team, %player);
	event::Trigger(eventFlagUpdate);
}